/*
;----------------------------------------------------------------;
;                40 New Best Routines (graphic)                  ;
;          (c) SerzhSoft, Shadrinsk, may-june, 1997              ;
;    old length: 1444 bytes         new length:  861 bytes       ;
;----------------------------------------------------------------;
; http://vladik1232008.narod.ru/ZX_FORUM_40_Best_procedures.html ;
;           Adapted to ZXDev/SDCC by Oleg N. Cher, 2012          ;
;----------------------------------------------------------------;
*/

void Best40_ASRL_LF (unsigned char atr) __z88dk_fastcall;
void Best40_ASRL_RG (unsigned char atr) __z88dk_fastcall;
void Best40_ASRL_UP (unsigned char atr) __z88dk_fastcall;
void Best40_ASRL_DN (unsigned char atr) __z88dk_fastcall;
void Best40_SSRL_LF (void);
void Best40_SSRL_RG (void);
void Best40_SSRL_UP (void);
void Best40_SSRL_DN (void);
void Best40_PSRL_LF (void);
void Best40_PSRL_RG (void);
void Best40_PSRL_UP (void);
void Best40_PSRL_DN (void);
void Best40_SCR_MRG (unsigned int scr_addr);
void Best40_SCR_INV (void);
void Best40_SINV_UD (unsigned int char_addr);
void Best40_SINV_LR (unsigned int char_addr);
void Best40_SROTATE (unsigned int char_addr);
void Best40_ACHANGE (unsigned char attr_and, unsigned char attr_or);
void Best40_AREPLC (unsigned char attr_from, unsigned char attr_to);
void Best40_PAINT (unsigned char x, unsigned char y);
unsigned char Best40_POINT (unsigned char x, unsigned char y);
void Best40_PFIGURE (unsigned char x, unsigned char y, unsigned char *pattern);
void Best40_PSCALER (unsigned char x1_old, unsigned char y1_old,
  unsigned char x2_old, unsigned char y2_old, unsigned char xscale,
  unsigned char yscale, unsigned char x_new, unsigned char y_new);
void Best40_PUTSPR (
  unsigned char x, unsigned char y, unsigned char len, unsigned char hgt,
  unsigned int adr, unsigned char mode);
void Best40_SCREEN_APART (unsigned char steps);
void Best40_PRSTR_AT_E (unsigned char x, unsigned char y, unsigned char *str) __z88dk_callee;
void Best40_FILLED_CIRCLE (unsigned char x, unsigned char y, unsigned char radius) __z88dk_callee;

/*================================== Header ==================================*/

//    (22<=23)

void Best40_ASRL_LF (unsigned char atr) __z88dk_fastcall {
__asm
          LD      DE,#0x5800   // DE=   
LP_ASLF$: LD      A,L          //    
          LD      H,D          //  DE  HL
          LD      L,E          //    HL  :
          INC     HL           //  HL=   
          LD      BC,#0x001F   // <  > - 1
          LDIR                 //    
          LD      (DE),A       //   
          LD      L,A
          INC     DE           //     
          LD      A,D          //    ,
          CP      #0x5B        //       ,
          JR      C,LP_ASLF$   //   STOP,   
__endasm;
} //Best40_ASRL_LF

/*--------------------------------- Cut here ---------------------------------*/

//    (21<=23)

void Best40_ASRL_RG (unsigned char atr) __z88dk_fastcall {
__asm
          LD      A,L          //    
          LD      DE,#0x5AFF   //    
LP_ASRG$: LD      H,D          //  DE  HL -
          LD      L,E          //     
          DEC     HL           //    
          LD      BC,#0x001F   // <  > - 1
          LDDR                 //    
          LD      (DE),A       //   
          DEC     DE           //     
          BIT     3,D          //      ,
          JR      NZ,LP_ASRG$  //      . 
__endasm;
} //Best40_ASRL_RG

/*--------------------------------- Cut here ---------------------------------*/

//    (19<=21)

void Best40_ASRL_UP (unsigned char atr) __z88dk_fastcall {
__asm
          LD      A,L          //     
          LD      HL,#0x5820   //    
          LD      DE,#0x5800   //    
          LD      BC,#0x02E0   // : 23   32 
          LDIR                 //  23   
LP_ASUP$: LD      (DE),A       //   
          INC     E            //     
          JR      NZ,LP_ASUP$  //  (E=0),   
__endasm;
} //Best40_ASRL_UP

/*--------------------------------- Cut here ---------------------------------*/

//    (20<=21)

void Best40_ASRL_DN (unsigned char atr) __z88dk_fastcall {
__asm
          LD      A,L          //     
          LD      HL,#0x5ADF   //     
          LD      DE,#0x5AFF   //     
          LD      BC,#0x02E0   // : 23   32 
          LDDR                 //  23   
LP_ASDN$: LD      (DE),A       //   
          DEC     E            //      
          JR      NZ,LP_ASDN$  //    (E=0),  STOP
          LD      (DE),A       //     
__endasm;
} //Best40_ASRL_DN

/*--------------------------------- Cut here ---------------------------------*/

//      (20<=21)

void Best40_SSRL_LF (void) {
__asm
          LD      DE,#0x4000   //   
LP_SSLF$: LD      H,D          //  
          LD      L,E          //   
          INC     HL           //    
          LD      BC,#0x001F   //   
          LDIR                 //     1 
          XOR     A            //    
          LD      (DE),A       //    ()  
          INC     DE           //     ()
          LD      A,D          //  
          CP      #0x58        //  "  ",
          JR      C,LP_SSLF$   //      . 
__endasm;
} //Best40_SSRL_LF

/*--------------------------------- Cut here ---------------------------------*/

//      (19<=22)

void Best40_SSRL_RG (void) {
__asm
          LD      DE,#0x57FF   //    
LP_SSRG$: LD      H,D          //   
          LD      L,E          //   
          DEC     HL           //   
          LD      BC,#0x001F   // : 31 
          LDDR                 //    
          XOR     A            //    
          LD      (DE),A       //   ()   
          DEC     DE           //     
          BIT     6,D          //     ""  ,
          JR      NZ,LP_SSRG$  //     
__endasm;
} //Best40_SSRL_RG

/*--------------------------------- Cut here ---------------------------------*/

//      (55<=68)

void Best40_SSRL_UP (void) {
__asm
          LD      DE,#0x4000   //   
LP_SSU1$: PUSH    DE           //     
          LD      BC,#0x0020   //   - 32 
          LD      A,E          //   DE  
          ADD     A,C          //   .  
          LD      L,A          //  HL   
          LD      A,D          //  ,     8.
          JR      NC,GO_SSUP$  //      E -
          ADD     A,#0x08      //   32    L.  -
GO_SSUP$: LD      H,A          //   ,  H=D+8
          LDIR                 //    (32 )
          POP     DE           //    
          LD      A,H          // :      -
          CP      #0x58        //  ? (  23 )
          JR      NC,LP_SSU2$  //  ,    
          INC     D            // ---------------------------------;
          LD      A,D          //              DOWN_DE
          AND     #0x07        //   
          JR      NZ,LP_SSU1$  //       
          LD      A,E          //         
          ADD     A,#0x20      //         (  DE)
          LD      E,A          //
          JR      C,LP_SSU1$   //   :  DE -  
          LD      A,D          //   : DE -   
          SUB     #0x08        //    
          LD      D,A          //
          JR      LP_SSU1$     // ---------------------------------;
LP_SSU2$: XOR     A            //  
LP_SSU3$: LD      (DE),A       //     -
          INC     E            //     
          JR      NZ,LP_SSU3$  //  : 32 
          LD      E,#0xE0      //   
          INC     D            //  ()  
          BIT     3,D          //    ?
          JR      Z,LP_SSU2$   //  ,   
__endasm;
} //Best40_SSRL_UP

/*--------------------------------- Cut here ---------------------------------*/

//      (55<=73)

void Best40_SSRL_DN (void) {
__asm
          LD      DE,#0x57FF   //    
LP_SSD1$: PUSH    DE           //    
          LD      BC,#0x0020   //    
          LD      A,E          //   HL
          SUB     C            //   
          LD      L,A          //   ,
          LD      A,D          //   
          JR      NC,GO_SSDN$  //    
          SUB     #0x08        //   8  ():
GO_SSDN$: LD      H,A          //  HL= ; DE=
          LDDR                 //    
          POP     DE           //    
          BIT     6,H          //      ,
          JR      Z,LP_SSD2$   //     
          LD      A,D          // ---------------------------------;
          DEC     D            //               UP_DE
          AND     #0x07        //   
          JR      NZ,LP_SSD1$  //       
          LD      A,E          //        
          SUB     #0x20        //         (  DE)
          LD      E,A          //
          JR      C,LP_SSD1$   //   :  DE -  
          LD      A,D          //   : DE -   
          ADD     A,#0x08      //    
          LD      D,A          //
          JR      LP_SSD1$     // ---------------------------------;
LP_SSD2$: XOR     A            //  
LP_SSD3$: LD      (DE),A       //  
          DEC     E            //   :
          JR      NZ,LP_SSD3$  //  (31 )
          LD      (DE),A       //     
          LD      E,#0x1F      //    ()
          DEC     D            //      
          BIT     6,D          //      ?
          JR      NZ,LP_SSD2$  //  ,   
__endasm;
} //Best40_SSRL_DN

/*--------------------------------- Cut here ---------------------------------*/

//      (16<=17)

void Best40_PSRL_LF (void) {
__asm
          LD      HL,#0x57FF   //    
LP_PSL1$: OR      A            //    CF
          LD      B,#0x20      //    - 32 
LP_PSL2$: RL      (HL)         // CF<-[ ]<-CF ()
          DEC     HL           //     
          DJNZ    LP_PSL2$     //     
          BIT     6,H          //    ?
          JR      NZ,LP_PSL1$  //  ,   . 
__endasm;
} //Best40_PSRL_LF

/*--------------------------------- Cut here ---------------------------------*/

//      (17)

void Best40_PSRL_RG (void) {
__asm
          LD      HL,#0x4000   //    
          LD      C,#0xC0      //  - 192 
LP_PSR1$: OR      A            // CF=0    
          LD      B,#0x20      //     
LP_PSR2$: RR      (HL)         //    
          INC     HL           //    
          DJNZ    LP_PSR2$     //    - 32 
          DEC     C            //   
          JR      NZ,LP_PSR1$  //    ,  STOP
__endasm;
} //Best40_PSRL_RG

/*--------------------------------- Cut here ---------------------------------*/

//      (38<=91)

void Best40_PSRL_UP (void) {
__asm
          LD      DE,#0x4000   //    (. )
LP_PSU1$: LD      H,D          //   
          LD      L,E          //     HL
          LD      BC,#0x0020   //   
          INC     H            // ---------------------------------;
          LD      A,H          //             DOWN_HL
          AND     #0x07        //   
          JR      NZ,GO_PSUP$  //       
          LD      A,L          //         
          ADD     A,C          //         (  HL)
          LD      L,A          //  ( ADD A,C  ADD A,#08)
          JR      C,GO_PSUP$   //   :  HL -  
          LD      A,H          //   : HL -   
          SUB     #0x08        //    
          LD      H,A          // ---------------------------------;
GO_PSUP$: PUSH    HL           //    
          LDIR                 //   -
          POP     DE           // DE -   
          LD      A,H          //      
          CP      #0x58        //      ?
          JR      C,LP_PSU1$   //    ,  
          XOR     A            //     
LP_PSU2$: LD      (DE),A       //    
          INC     E            //    
          JR      NZ,LP_PSU2$  //     
__endasm;
} //Best40_PSRL_UP

/*--------------------------------- Cut here ---------------------------------*/

//      (38<=90)

void Best40_PSRL_DN (void) {
__asm
          LD      DE,#0x57FF   //    
LP_PSD1$: LD      H,D          //   
          LD      L,E          //     HL
          LD      BC,#0x0020   //    
          LD      A,H          // ---------------------------------;
          DEC     H            //               UP_HL
          AND     #0x07        //   
          JR      NZ,GO_PSDN$  //       
          LD      A,L          //        
          SUB     C            //         (  HL)
          LD      L,A          //    ( SUB C  SUB #08)
          JR      C,GO_PSDN$   //   :  HL -  
          LD      A,H          //   : HL -   
          ADD     A,#0x08      //    
          LD      H,A          // ---------------------------------;
GO_PSDN$: PUSH    HL           //    
          LDDR                 //  1   - 
          POP     DE           //     
          BIT     6,H          //       -
          JR      NZ,LP_PSD1$  //     
          XOR     A            //     
LP_PSD2$: LD      (DE),A       //   -   
          DEC     E            //    
          JR      NZ,LP_PSD2$  //    
          LD      (DE),A       //    
__endasm;
} //Best40_PSRL_DN

/*--------------------------------- Cut here ---------------------------------*/

//   (17<=21)

void Best40_SCR_MRG (unsigned int scr_addr) __naked {
__asm
          POP     DE
          POP     HL           //     
          PUSH    HL
          PUSH    DE
          LD      DE,#0x4000   //   
LP_SCRM$: LD      A,(DE)       //    
          OR      (HL)         // ""     
          LD      (DE),A       //     
          INC     HL           //     
          INC     DE           //    
          LD      A,D          //   
          CP      #0x58        //   
          JR      C,LP_SCRM$   //   ,  
          RET
__endasm;
} //Best40_SCR_MRG

/*--------------------------------- Cut here ---------------------------------*/

//   (12<=18)

void Best40_SCR_INV (void) {

__asm
          LD      HL,#0x57FF   //    
LP_SCRI$: LD      A,(HL)       //     
          CPL                  //  
          LD      (HL),A       //   
          DEC     HL           //    
          BIT     6,H          //  ""  ,
          JR      NZ,LP_SCRI$  //   STOP,   
__endasm;
} //Best40_SCR_INV

/*--------------------------------- Cut here ---------------------------------*/

//    (20)

void Best40_SINV_UD (unsigned int char_addr) __naked {
__asm
          POP     DE
          POP     HL           //     
          PUSH    HL
          PUSH    DE
          LD      D,H          //  
          LD      E,L          //    DE
          LD      B,#0x08      //   - 8 
LP_SIU1$: LD      A,(HL)       //    
          PUSH    AF           //    
          INC     HL           //     
          DJNZ    LP_SIU1$     //     
          LD      B,#0x08      //    
LP_SIU2$: POP     AF           //       -
          LD      (DE),A       //      
          INC     DE           //   
          DJNZ    LP_SIU2$     //    
          RET
__endasm;
} //Best40_SINV_UD

/*--------------------------------- Cut here ---------------------------------*/

//    (17<=19)

void Best40_SINV_LR (unsigned int char_addr) {
__asm
          POP     DE
          POP     HL           //     
          PUSH    HL
          PUSH    DE
          LD      B,#0x08      // : 8 
LP_SIL1$: LD      A,#0x01      //    A  1
LP_SIL2$: RR      (HL)         //    
          RLA                  //   -  ( CF)
          JR      NC,LP_SIL2$  //       CF
          LD      (HL),A       //   
          INC     HL           //   
          DJNZ    LP_SIL1$     //   8 
          RET
__endasm;
} //Best40_SINV_LR

/*--------------------------------- Cut here ---------------------------------*/

//      (26<=42)

void Best40_SROTATE (unsigned int char_addr) {
__asm
          POP     DE
          POP     HL           //     
          PUSH    HL
          PUSH    DE
          LD      B,#0x08      // 8    
LP_SRO1$: PUSH    HL           //    
          LD      A,#0x80      //  7-   
LP_SRO2$: RR      (HL)         //    
          RRA                  //        
          INC     HL           //    
          JR      NC,LP_SRO2$  //   7 .     CF
          POP     HL           //   
          PUSH    AF           // .   -  
          DJNZ    LP_SRO1$     //     
          LD      B,#0x08      //    - 
LP_SRO3$: POP     AF           //    
          LD      (HL),A       //   -    
          INC     HL           //   
          DJNZ    LP_SRO3$     //     (8 )
          RET
__endasm;
} //Best40_SROTATE

/*--------------------------------- Cut here ---------------------------------*/

//   (16<=21)

void Best40_ACHANGE (unsigned char attr_and, unsigned char attr_or) __naked {
__asm
          POP     HL
          POP     BC           // C -     AND
          PUSH    BC           // B -     OR
          LD      DE,#0x5AFF   //    
LP_ACHN$: LD      A,(DE)       //    
          AND     C            //   
          OR      B            //  
          LD      (DE),A       //     
          DEC     DE           //    
          BIT     3,D          //     ?
          JR      NZ,LP_ACHN$  //  ,   
          JP      (HL)
__endasm;
} //Best40_ACHANGE

/*--------------------------------- Cut here ---------------------------------*/

//   (18<=22)

void Best40_AREPLC (unsigned char attr_from, unsigned char attr_to) __naked {
__asm
          POP     HL
          POP     DE           // E -  
          PUSH    DE           // D -  
          PUSH    HL
          LD      HL,#0x5AFF   //    
LP_ARPL$: LD      A,(HL)       //     
          CP      E            //   ,  ?
          JR      NZ,GO_ARPL$  // ,  
          LD      (HL),D       // ,    
GO_ARPL$: DEC     HL           //    - 
          BIT     3,H          //    ?
          JR      NZ,LP_ARPL$  //  ,   
          RET
__endasm;
} //Best40_AREPLC

/*--------------------------------- Cut here ---------------------------------*/

//   (123<=263)
//  123=88+35 -    POINT

void Best40_PAINT (unsigned char x, unsigned char y) __naked {
__asm
          POP     DE
          POP     HL           // L =  X  
          PUSH    HL           //  Y  
          PUSH    DE
          LD      A,H          //   Y  
          CP      #0xC0        //    :
          RET     NC           //   Y>=192,   
          SBC     A,A          // .. CF=1,  SBC A,A  A=#FF -
          PUSH    AF           //      
          PUSH    HL           //    
LP_PNT1$: POP     DE           //    X,Y . 
          INC     D            //  Y=#FF,   ,
          RET     Z            //      
          DEC     D            //  .  Y
          CALL    __POINT__    //    - (E,D)
          JR      NZ,LP_PNT1$  //  ,    .
          EX      AF,AF        // A'=0, CF=0 - . 
LP_PNT2$: LD      A,E          //   X
          OR      A            //    ,
          JR      Z,GO_PNT1$   //      
          DEC     E            //  -   X
          CALL    __POINT__    //    
          JR      Z,LP_PNT2$   //  " ", 
LP_PNT3$: INC     E            //     (X=X+1)
          JR      Z,LP_PNT1$   //  X>255,  .   
GO_PNT1$: CALL    __POINT__    //    
          JR      NZ,LP_PNT1$  //  ,  .  
          LD      A,(HL)       //    ,
          OR      C            //      , 
          LD      (HL),A       //      
          LD      A,D          //   Y:
          OR      A            //    ,
          JR      Z,GO_PNT4$   //     .  
          DEC     D            //     (Y=Y-1)
          CALL    __POINT__    //   
          JR      Z,GO_PNT2$   //   ,  
          EX      AF,AF        //   
          LD      A,B          //     
          JR      GO_PNT3$     //   
GO_PNT2$: EX      AF,AF        //   
          INC     A            //  A>0,    
          DEC     A            //     
          JR      NZ,GO_PNT3$  //    , -> 
          LD      A,C          //  -   -
          PUSH    DE           //  ,     
GO_PNT3$: EX      AF,AF        //   
          INC     D            //    
GO_PNT4$: LD      A,D          //   Y:
          CP      #0xBF        //  -  (  ),
          JR      NC,LP_PNT3$  //     .  
          INC     D            //  -    
          CALL    __POINT__    //   
          JR      Z,GO_PNT5$   //   ,  
          EX      AF,AF        //   
          AND     A            //     
          JR      GO_PNT6$     //   
GO_PNT5$: EX      AF,AF        //   
          JR      C,GO_PNT6$   //   ,  
          SCF                  //     
          PUSH    DE           //      
GO_PNT6$: EX      AF,AF        //   
          DEC     D            //    
          JR      LP_PNT3$     //     
__endasm;
} //Best40_PAINT

/*--------------------------------- Cut here ---------------------------------*/

//         (35<=70)

unsigned char Best40_POINT (unsigned char x, unsigned char y) {
__asm
          POP     HL
          POP     DE           // E =  X
          PUSH    DE           // D =  Y
          PUSH    HL
          CALL    __POINT__    //  POINT
          LD      L,A          // : 0 (FALSE)   0 (TRUE)
__endasm;
} //Best40_POINT

/*--------------------------------- Cut here ---------------------------------*/

//   ,  ZF=1 (Z),  ZF=0 (NZ)

void _POINT__ (void) {
__asm
          LD      B,#0x07      //    (#07)
          LD      A,D          //  Y-
          RRA                  //    8
          SCF                  //    
          RRA                  //   
          RRA                  //   
          AND     #0x5F        //    ( H):
          LD      H,A          //   %010yyyyy
          XOR     E            //  
          AND     B            //   
          XOR     E            //  
          RRCA                 //  
          RRCA                 //   
          RRCA                 //  ( L):
          LD      L,A          //   %yyyxxxxx
          LD      A,D          // 
          XOR     H            //  
          AND     B            //   
          XOR     H            //   
          LD      H,A          //    ( H)
          LD      A,E          //  
          AND     B            //     
          LD      B,A          //   (
          LD      A,#0x80      //   ).  7- 
          JR      Z,GO_PNT$    //       ,
LP_PNT$:  RRCA                 //     
          DJNZ    LP_PNT$      //    
GO_PNT$:  LD      C,A          //   .   . C
          AND     (HL)         //    
__endasm;
} //_POINT__

/*--------------------------------- Cut here ---------------------------------*/

//   (98<=196)
//  98+35=133 -    POINT

void Best40_PFIGURE_E (unsigned char x, unsigned char y, unsigned char *pattern) __naked {
__asm
          POP     BC
          POP     DE           //  E=X, D=Y  
          POP     HL           //   pattern  
          PUSH    BC
          PUSH    BC
          PUSH    BC
          DEC     HL           //     
LP_PFG3$: INC     HL           //    ,   ..
          LD      A,(HL)       //     
          OR      A            //    (   0)
          RET     Z            //    
          CP      #"0"         //   "  "?
          JR      NZ,GO_PFG6$  //  ,   
          LD      A,D          // y-  
          CP      #0xC0        //     
          JR      NC,LP_PFG3$  //  ,    
          PUSH    HL           //  -  
          PUSH    BC           //  ,   
          CALL    __POINT__    //    
          LD      A,(HL)       //   
          OR      C            //     
          LD      (HL),A       //   ,  HL=,
          POP     BC           //    C   
          POP     HL           //  - 
          JR      LP_PFG3$     //  .  
GO_PFG6$: SUB     #"5"         //   ?
          JR      NZ,GO_PFG7$  //  ,     
          DEC     E            //  -  x-
GO_PFG7$: DEC     A            //  ?
          JR      NZ,GO_PFG8$  // , 
          INC     D            // ,  y-
GO_PFG8$: DEC     A            //  ""?
          JR      NZ,GO_PFG9$  // , 
          DEC     D            // ,  y-
GO_PFG9$: DEC     A            //    ?
          JR      NZ,LP_PFG3$  // ,   .  .
          INC     E            // ,  x-
          JR      LP_PFG3$     //     .  .
__endasm;
} //Best40_PFIGURE_E

/*--------------------------------- Cut here ---------------------------------*/

//     (174<=335)
//  174+35=209 -    POINT

void Best40_PSCALER (unsigned char x1_old, unsigned char y1_old,
  unsigned char x2_old, unsigned char y2_old, unsigned char xscale,
  unsigned char yscale, unsigned char x_new, unsigned char y_new) __naked {
__asm
          PUSH    IX
          LD      IX,#4
          ADD     IX,SP
          CALL    __PSCALER__
          POP     IX
          RET
__endasm;
} //Best40_PSCALER

/*--------------------------------- Cut here ---------------------------------*/
void _PSCALER__ (void) {
__asm
          LD      L,4(IX)
          LD      H,5(IX)      ;   x  y
          INC     L            ; x-
          DEC     L            ;   
          RET     Z            ;  0,   ()
          INC     H            ; y-
          DEC     H            ;   
          RET     Z            ;  0,   ()
          LD      L,6(IX)
          LD      H,7(IX)      ; x-,y- ("")
          LD      A,#0xBF      ;  y-
          CP      H            ;  y-
          RET     C            ;    - 
          LD      L,0(IX)
          LD      H,1(IX)      ;x1-,y1- ("")
          CP      H            ; y1    
          RET     C            ;  ,  
          LD      E,2(IX)
          LD      D,3(IX)      ;x2-,y2- ("")
          CP      D            ;y2   ?
          RET     C            ; ,    
          LD      A,E          ; x2
          CP      L            ;   x1
          JR      NC,GO_PSC1$  ; L  E,   
          EX      DE,HL        ; -   
GO_PSC1$: LD      A,D          ; y2
          CP      H            ;   y1
          JR      NC,GO_PSC2$  ; H  D,  
          LD      D,H          ; - 
          LD      H,A          ;  
GO_PSC2$: LD      A,D          ;  y-
          SUB     H            ;  y-
          INC     A            ;  1
          EXX                  ;   
          LD      B,A          ;   y ()
          EXX                  ;   
          LD      A,E          ;  x-
          SUB     L            ;  x-
          INC     A            ; 
          EXX                  ;  
          LD      C,A          ;   x ()
          EXX                  ;  .  
          PUSH    AF           ;     ()
          INC     SP           ; -    
          LD      C,#0x08      ;    
LP_PSC1$: LD      A,E          ;   -
          EX      AF,AF        ;  . x  
LP_PSC2$: PUSH    HL           ;  HL,BC  
          PUSH    BC           ;   
          CALL    __POINT__    ;   
          POP     BC           ; 
          POP     HL           ;  BC,HL  
          ADD     A,#0xFF      ; A>0,   CF 
          RR      B            ;""     B
          DEC     C            ;   
          JR      NZ,GO_PSC3$  ;  ,  
          PUSH    BC           ; -   
          INC     SP           ;  B ( 1 )
          LD      C,#0x08      ;    
GO_PSC3$: LD      A,E          ; x-
          DEC     E            ;   
          CP      L            ;   
          JR      NZ,LP_PSC2$  ;   
          EX      AF,AF        ; 
          LD      E,A          ; x-   A
          LD      A,D          ; y-
          DEC     D            ;   
          CP      H            ;   ?
          JR      NZ,LP_PSC1$  ; ,     
          LD      A,#0x08      ;   
          SUB     C            ;A=    . B
          JR      NZ,GO_PSC4$  ;  ,  
          LD      A,C          ;A=C=8 -    
          DEC     SP           ;   
          POP     BC           ;   
GO_PSC4$: LD      C,A          ;    . 
          LD      E,6(IX)
          LD      D,7(IX)      ; x-,y- ("")
LP_PSC3$: LD      A,E          ; x- 
          EX      AF,AF        ;    A''
          EXX                  ;   
          LD      E,C          ;     x
LP_PSC4$: EXX                  ;  .  
          EX      AF,AF        ;  . . 
          RLC     B            ; CF - /_. 
          EX      AF,AF        ;   
          PUSH    BC           ;    . 
          LD      L,4(IX)
          LD      H,5(IX)      ;   x  y
          LD      B,H          ;  
          LD      C,L          ;   C  B (x  y)
          PUSH    DE           ; - (  )
LP_PSC5$: PUSH    DE           ; - (  )
LP_PSC6$: PUSH    HL           ;  HL  BC
          PUSH    BC           ;    POINT
          CALL    __POINT__    ;     
          LD      A,C          ;  ( )
          POP     BC           ; BC  
          EX      AF,AF        ;   CF
          JR      C,GO_PSC5$   ;  ,  
          EX      AF,AF        ;   CF
          CPL                  ;   
          AND     (HL)         ;      
          JR      GO_PSC6$     ;  
GO_PSC5$: EX      AF,AF        ; CF   -
          OR      (HL)         ; 
GO_PSC6$: LD      (HL),A       ;    
          POP     HL           ; HL (. )
          INC     E            ;  .    
          DEC     L            ;    x
          JR      NZ,LP_PSC6$  ;  ,  
          LD      L,C          ;  x-.
          POP     DE           ;-   
          INC     D            ;     
          DEC     H            ;    y
          JR      NZ,LP_PSC5$  ; ,     0
          LD      H,B          ;  y-.
          POP     DE           ;-   
          LD      A,E          ;   
          ADD     A,L          ; , 
          LD      E,A          ;    ()
          POP     BC           ;  -  
          DEC     C            ;     B
          JR      NZ,GO_PSC7$  ;   ,  
          DEC     SP           ; -   
          POP     BC           ;      B
          LD      C,#0x08      ;  
GO_PSC7$: EXX                  ;   
          DEC     E            ;    
          JR      NZ,LP_PSC4$  ;   ,  
          EXX                  ;  .  
          EX      AF,AF        ;  
          LD      E,A          ;  x- 
          LD      A,D          ;    -
          ADD     A,H          ; ,  
          LD      D,A          ;   ()
          EXX                  ;   
          DEC     B            ;   
          EXX                  ;  .  
          JR      NZ,LP_PSC3$  ;,    
__endasm;
} //Best40_PSCALER

/*--------------------------------- Cut here ---------------------------------*/
/*

   http://zxpress.ru/book_articles.php?id=671

   ,      0  
       . 
   ,     
       ,       
. ,      ,    
,   .   220 .

Listing 2.   

;      SPRITE OUTPUT 2.3
;      (C)SERZHSOFT'1996

*/

void Best40_PUTSPR (
  unsigned char x, unsigned char y, unsigned char len, unsigned char hgt,
  unsigned int adr, unsigned char mode) {
__asm
         PUSH    IX
         LD      IX,#4
         ADD     IX,SP
         LD      D,0(IX)  ;X- 
         LD      E,1(IX)  ;Y- 
         LD      B,2(IX)  ;   
         LD      C,3(IX)  ;   
         LD      L,4(IX)  ; 
         LD      H,5(IX)  ;  
         LD      A,6(IX)  ;   
PUTSPR$: ;   . 
         ;D: X-, E: Y-
         ;B: , C: 
         ;HL:  
         ;A:   (0=OR, 1=XOR, 2=AND)
         EX      AF,AF    ; 
         XOR     A        ;  -
         EX      AF,AF    ;     
         CP      #1       ;:
         LD      A,#180   ;  A<1 (.. A=0), 
         JR      C,GOPS1$ ; A=180 (OR H)  
         LD      A,#172   ; A=1, 
         JR      Z,GOPS1$ ; A=172 (XOR H)  
         LD      A,#164   ; A>1,  A=164 (AND H)
         EX      AF,AF    ; AND,  
         CPL              ; AF''=255,  
         EX      AF,AF    ;  (A=0, CPL => A=255)
GOPS1$:  LD      (#MODE_1$),A    ;
         INC     A               ; 
         LD      (#MODE_2$),A    ;  
         INC     A               ;  
         LD      (#MODE_5$),A    ;   (OR, XOR, AND)
         EX      AF,AF           ;A= 
         LD      (#MODE_0$+1),A  ; " "
         AND     D               ; ""  X-.
         AND     #0x7            ; A=0..7: 
         LD      (#MODE_4$+2),A  ;   TBL_OR
         LD      A,D      ; X
         AND     #0x7     ;     
         EX      AF,AF    ;  AF''
         PUSH    HL       ;    
         LD      A,#0xBF  ; Y-
         SUB     E        ; 
         LD      E,A      ; -
         LD      A,E      ;------------------------
         RRA              ;    
         SCF              ;     :
         RRA              ;
         RRA              ; :
         AND     #0x5F    ; D=X-
         LD      H,A      ; E=Y-
         XOR     D        ;
         AND     #0x7     ; :
         XOR     D        ; HL=  
         RRCA             ;
         RRCA             ;D,E   
         RRCA             ;
         LD      L,A      ;
         LD      A,E      ; 
         XOR     H        ;
         AND     #0x7     ;
         XOR     H        ;
         LD      H,A      ;------------------------
         EX      AF,AF           ;  
         JR      Z,NOSHFT$       ; =0,  
         LD      (#JUMPER$+1),A  ;  JR  
         LD      IX,#TBL_OR$     ;IX=  TBL_OR
MODE_4$: LD      A,0(IX)         ;   0..7 
         LD      (#MODE_3$+1),A  ;  ( OR)
         POP     IX       ;IX=  
         EX      DE,HL    ;DE=   
LPPS1$:  PUSH    BC       ;   
         LD      A,E      ;  E
         EX      AF,AF    ;  AF''
LPPS2$:  LD      L,0(IX)  ;L= 
MODE_0$: LD      H,#0x0   ;H=0  OR, XOR; H=255  AND
JUMPER$: JR      .+2      ;   ADD HL,HL
         ADD     HL,HL    ;-------------
         ADD     HL,HL    ;
         ADD     HL,HL    ; 
         ADD     HL,HL    ; 
         ADD     HL,HL    ; 
         ADD     HL,HL    ;  
         ADD     HL,HL    ;
         ADD     HL,HL    ;-------------
         LD      A,(DE)   ;   
MODE_1$: OR      H        ;OR, XOR  AND
         LD      (DE),A   ; 
         INC     E        ;  
         LD      A,L      ;  L 
MODE_3$: OR      #0x0     ;   (-
         LD      L,A      ;  ADD HL,HL', A RLC HL')
         LD      A,(DE)   ;  
MODE_2$: OR      L        ;OR,XOR  AND
         LD      (DE),A   ; 
         INC     IX       ;  
         DJNZ    LPPS2$   ; "" 
         EX      AF,AF    ;
         LD      E,A      ;  E
         INC     D        ;  
         LD      A,D      ; . 3   D
         AND     #0x7     ;  , 
         JR      Z,GOPS3$ ;   
GOPS2$:  POP     BC       ;   
         DEC     C        ; 
         JR      NZ,LPPS1$; "" 
         POP     IX
         RET              ;  
GOPS3$:  LD      A,E      ;--------------------
         ADD     A,#0x20  ;
         LD      E,A      ; DE
         JR      C,GOPS2$ ;   
         LD      A,D      ;  
         SUB     #0x8     ; ( )
         LD      D,A      ;
         JR      GOPS2$   ;--------------------
;
NOSHFT$: ;    (X-  8)
         POP     DE       ;DE=   
LPPS3$:  PUSH    BC       ;   
         LD      A,L      ;
         EX      AF,AF    ;  L  AF''
LPPS4$:  LD      A,(DE)   ;  
MODE_5$: OR      (HL)     ;OR, XOR  AND
         LD      (HL),A   ;  
         INC     DE       ;  
         INC     L        ;  
         DJNZ    LPPS4$   ; "" 
         EX      AF,AF    ;
         LD      L,A      ;  L
         INC     H        ;    
         LD      A,H      ;  3   H
         AND     #0x7     ;  , 
         JR      Z,GOPS5$ ;   
GOPS4$:  POP     BC       ;   
         DEC     C        ;
         JR      NZ,LPPS3$; "" 
         POP     IX
         RET              ;  
GOPS5$:  LD      A,L      ;-------------------
         ADD     A,#0x20  ;
         LD      L,A      ; HL
         JR      C,GOPS4$ ;  
         LD      A,H      ;   
         SUB     #0x8     ; ( )
         LD      H,A      ;
         JR      GOPS4$   ;-------------------
;
;       
;(   "RLC HL"  ADD HL,HL)
TBL_OR$: .DB     #0x00,#0x7F,#0x3F,#0x1F,#0x0F,#0x07,#0x03,#0x01
;
;END OF SPRITE OUTPUT 2.3
__endasm;
} //Best40_PUTSPR

/*--------------------------------- Cut here ---------------------------------*/
void Best40_SCREEN_APART (unsigned char steps) {
__asm
;  SCREEN-APART
;(c) SerzhSoft, 11 july 1997

          LD      HL,#2
          ADD     HL,SP
          LD      B,(HL)      ;B=     
APART$:                       ;  ATTR_P
LP_APR1$: PUSH    BC          ;    
          LD      A,(23693)   ;A=  .  
          LD      DE,#0x5AFF  ;   
LP_APR2$: LD      H,D         ;  
          LD      L,E         ;  HL    1:
          DEC     HL          ;    
          LD      BC,#0x000F  ;: 15 
          LDDR                ;  - 
          LD      (DE),A      ;  
          LD      BC,#0xFFF2  ; - HL -  
          ADD     HL,BC       ;     
          LD      E,L         ;DE=HL
          DEC     E           ;    
          LD      BC,#0x000F  ;  15 
          LDIR                ;  - 
          LD      (DE),A      ;   ()
          LD      BC,#0xFFEF  ;  DE -
          ADD     HL,BC       ;   
          EX      DE,HL       ;     ()
          BIT     3,D         ;   ,
          JR      NZ,LP_APR2$ ;   
          XOR     A           ;   
          BIT     6,D         ;       ,
          JR      NZ,LP_APR2$ ;    
          POP     BC          ;  
          DJNZ    LP_APR1$    ;    
__endasm;
} //Best40_SCREEN_APART

/*--------------------------------- Cut here ---------------------------------*/
void Best40_PRSTR_AT_E (unsigned char x, unsigned char y, unsigned char *str) __naked __z88dk_callee {
__asm
;        Y
;(c) Steve Turner, Body #06
; http://zxpress.ru/article.php?id=3206

          POP     HL
          POP     DE
          EX      (SP),HL
          LD      (INPUT$+1),HL
          LD      A,D
          AND     #0x38       ; 
          ADD     A
          ADD     A
          ADD     E           ; 
          LD      E,A         ; 
          LD      A,D
          RRA
          RRA
          RRA
          AND     #0x18       ;  
          LD      B,A
          LD      A,D
          AND     #0x7        ;  
          ADD     B
          ADD     #0x40       ; 
          LD      D,A
INPUT$:   LD      HL,#0       ; 
          LD      A,(HL)
          OR      A
          RET     Z           ; 
          LD      (OUTPUT$+1),DE
          INC     HL
          LD      (INPUT$+1),HL
          CP      #0xFF
          JR      NZ,CHAR$    ;       
OUTLIN$:  LD      DE,#0       ; 
          LD      A,E
          ADD     #0x20
          LD      E,A
          RET     NC
          LD      A,D         ;  
          ADD     #8
          CP      #0x58
          RET     NC
          LD      D,A
          LD      (OUTLIN$+1),DE
          JR      INPUT$
CHAR$:    LD      L,A          ; 
          LD      H,#0
          ADD     HL,HL
          ADD     HL,HL
          ADD     HL,HL
          LD      DE,(23606)   ;     256 
          ADD     HL,DE
OUTPUT$:  LD      DE,#0        ; 
          LD      A,D
          CP      #0x58
          RET     NC
          LD      B,#8
EIGHT$:   LD      A,(HL)       ; 8  
          LD      (DE),A
          INC     HL
          LD      A,D
          AND     #7
          INC     A
          CP      #8
          JR      NZ,NONEW$
          LD      A,D
          AND     #0xF8
          LD      D,A
          LD      A,E
          ADD     #0x20
          LD      E,A
          JR      NC,NEXTSL$
          LD      A,D
          ADD     #8
          LD      D,A
NONEW$:   INC     D
NEXTSL$:  DJNZ    EIGHT$
          LD      DE,(OUTPUT$+1)
NEXTLT$:  INC     E
          JR      NZ,INPUT$
          LD      A,D
          ADD     #8
          LD      D,A
          JR      INPUT$
__endasm;
} //Best40_PRSTR_AT_E

/*--------------------------------- Cut here ---------------------------------*/
void Best40_FILLED_CIRCLE (unsigned char x, unsigned char y, unsigned char radius) __naked __z88dk_callee {
__asm
; https://github.com/impomatic/z80snippets/blob/master/filledcircle.asm

; FAST FILLED CIRCLE - Sinclair Spectrum, displays filled circle
; on entry, d = x-centre, e = y-centre, c = radius
; on exit, a, bc, de, hl corrupt
; Length 106 - John Metcalf, Sun 28 Feb 1999

; Draws filled circles very quickly. An assortment of tricks have
; been used to achieve this. This new version is over 10% faster
; than the previous after further optimizing the inner loops.

          POP   HL
          POP   BC
          LD    E,B
          LD    D,C       ; E = X-centre, D = Y-centre
          DEC   SP
          POP   BC
          LD    C,B       ; C = radius
          PUSH  HL

          LD    B,#0
          LD    A,E       ; Subtract radius from y-centre
          INC   C
          SUB   C
          LD    E,A

          LD    H,B       ; HL = 0
          LD    L,B

NEXT$:    PUSH  BC
          PUSH  HL

          LD    BC,#65280 ; Triangular root :-)
CALC$:    DEC   C
          ADD   HL,BC
          JR    C,CALC$

          LD    A,E       ; Calc pos in screen memory
          CP    #192
          JR    NC,OFFSCR$
          RRCA
          SCF
          RRA
          RRCA
          LD    L,A
          XOR   E
          AND   #88
          XOR   E
          AND   #95
          LD    H,A

          LD    A,D
          ADD   A,C
          RL    C
          LD    B,A
          XOR   L
          AND   #7
          XOR   B
          RRCA
          RRCA
          RRCA
          LD    L,A

          XOR   A         ; Calc first part byte (if any)
          SUB   B
          AND   #7
          JR    Z,NOHALF$
          LD    B,A
          XOR   A
          DEC   C
VAIN$:    INC   C
          JR    Z,ROTB$
          SCF
          RLA
          DJNZ  VAIN$
          INC   C
          OR    (HL)
          LD    (HL),A
          INC   HL
NOHALF$:  XOR   A         ; Calc full bytes (if any)
          SUB   C
          RRCA
          RRCA
          RRCA
          AND   #31
          JR    Z,NOFULL$
          LD    B,A
          LD    A,#255
DRAW$:    LD    (HL),A
          INC   HL
          DJNZ  DRAW$
NOFULL$:  LD    A,C       ; Calc final part byte (if any)
          AND   #7
          JR    Z,OFFSCR$
          LD    B,A
          LD    A,#255
ROTB$:    ADD   A,A
          DJNZ  ROTB$
DISPLAY$: OR    (HL)
          LD    (HL),A

OFFSCR$:  POP   HL
          POP   BC
          INC   E         ; Next line
          DEC   C
          JR    NZ,SKIP$
          DEC   BC
SKIP$:    ADC   HL,BC
          JR    NZ,NEXT$
          RET
__endasm;
} //Best40_FILLED_CIRCLE


/* https://github.com/impomatic/z80snippets/
   http://zxpress.ru/book_articles.php?id=671

*********************************************
(c)  , .

    ZX  96/4-5,   "",     
. ,   .    ,   
    . "   !" -   
  .
           .   
,       . , "" :
Listing 1.  .

REDEF   ;    
        ; :
        ; B=   
        ; A=   (   1)
        LD      BC,#FEFE ;   
LP_DEF  RRC     B        ;""  
        IN      A,(C)    ;   
        CPL              ;  
        AND     #1F      ; 3  
        JR      Z,LP_DEF ;  ,  
        RET              ;  
;
TRANSF  ;  REDEF   
        ; :
        ; B=   
        ; A=   (   1)
        ; :
        ; A=  (C.S.=#E3, S.S.=#0E, ENTER=#0D)
        LD      H,B     ;H= 
        LD      B,#04   ;
LPTR1   RRA             ; 
        JR      C,GOTR1 ; 
        DJNZ    LPTR1   ; 
GOTR1   LD      A,B     ;  
        ADD     A,A     ;
        ADD     A,A     ; 
        ADD     A,A     ;  8
        LD      B,#07   ;
LPTR2   RR      H       ; 
        JR      NC,GOTR2; 
        DJNZ    LPTR2   ; 
GOTR2   ADD     A,B     ; K 
        ADD     A,#05   ;
        LD      L,A     ;  
        LD      H,#02   ;   : #0205
        LD      A,(HL)  ;A=   
        RET             ;  

    REDEF.       ( RESET, ), 
      A   B (  : " 
!").  B           (),
       (  ).
  13 .
    TRANSF -    .   
 ,    
  (  #0205),       .  
A=(#30..#39, #41..#5A) -     .  
,       : SPACE - #20,
CAPS SHIFT - #E3,  SYMBOL SHIFT - #0E, ENTER - #0D.   28 .

*/

/*

CODING -  .
http://zxpress.ru/article.php?id=7876

     .
http://zxpress.ru/article.php?id=1692
http://zxpress.ru/article.php?id=7872

  -   .
http://zxpress.ru/article.php?id=5525

 " " (SHADOW-PROCESSOR)
http://zxpress.ru/article.php?id=1766

    "".
http://zxpress.ru/book_articles.php?id=668

*/
