@echo off

if "%1" == "clean" goto clean
if "%1" == "main" goto main
if "%1" == "buildall" goto buildall
if "%1" == "" goto main

echo Unknown option.
echo Usage:
echo make clean    = clean from intermediate files
echo make buildall = builds all except main.c
echo make main     = builds main.c and creates ROM file

goto end

:clean
  echo * cleaning ...
  del *.rom > nul
  del *.sym > nul
  del *.lnk > nul
  del *.ihx > nul
  del *.map > nul
  del *.lst > nul
  del *.o   > nul
  del *.asm > nul
  del *.bin > nul
  del 64k.mem   > nul
  del 16kmem.a? > nul
  goto end

:buildall
  echo * building all except main ...
  sdcc --data-loc 0xc000 --code-loc 0x4020 -mz80 -c msx.c
  sdcc --data-loc 0xc000 --code-loc 0x4020 -mz80 -c msxvideo.c
  sdcc --data-loc 0xc000 --code-loc 0x4020 -mz80 -c msxaudio.c
  sdcc --data-loc 0xc000 --code-loc 0x4020 -mz80 -c msxutil.c
  sdcc --data-loc 0xc000 --code-loc 0x4020 -mz80 -c starship.c
  goto main

:main

  echo * building main
  sdcc --data-loc 0xc000 --code-loc 0x4020 -mz80 -omain.ihx msx.o msxvideo.o msxaudio.o msxutil.o starship.o main.c
  goto binary

:binary

  echo * binary manipulation: main.ihx -> inertia.rom ...
  makebin -s 65536 < main.ihx >64k.mem

  rem "split" is a GNU utility to break a file into parts.
  rem We only need the 2nd quarter of 64k.mem.

  split -b 16384 64k.mem 16kmem.
  move 16kmem.ab inertia.rom

  goto completed

:completed
  echo * ROM image name is inertia.rom (4000h-7FFFh)
  echo * end

:end
